.\"	$NetBSD: pcweasel.4,v 1.4 2007/11/23 11:40:50 xtraeme Exp $
.\"
.\" Copyright (c) 2000 Zembu Labs, Inc.
.\" All rights reserved.
.\"
.\" Author: Jason R. Thorpe <thorpej@zembu.com>
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement:
.\"	This product includes software developed by Zembu Labs, Inc.
.\" 4. Neither the name of Zembu Labs nor the names of its employees may
.\"    be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY ZEMBU LABS, INC. ``AS IS'' AND ANY EXPRESS
.\" OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WAR-
.\" RANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DIS-
.\" CLAIMED.  IN NO EVENT SHALL ZEMBU LABS BE LIABLE FOR ANY DIRECT, INDIRECT,
.\" INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
.\" NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
.\" DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
.\" THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
.\" (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
.\" THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd November 23, 2007
.Dt PCWEASEL 4
.Os
.Sh NAME
.Nm pcweasel
.Nd Support for the PC-Weasel serial console board
.Sh SYNOPSIS
.Cd "pseudo-device pcweasel"
.Cd "weasel* at pci? dev ? function ?"
.Pp
Note that the appropriate display device must also be enabled.
See
.Xr pcdisplay 4
for more information.
.Sh DESCRIPTION
The PC-Weasel is a serial console board for use primarily on
Intel-based PC-class systems.
It addresses a problem that nearly everyone who has deployed a
PC-class server has experienced: the total lack of remote management
capability on PC-class hardware.
.Pp
In addition to serial console support, the PC-Weasel provides the
ability to remotely reset the system (by means of a hardware reset
signal), and provides a watchdog timer function.
.Pp
The PC-Weasel works by emulating the original IBM Monochrome
Display Adapter (MDA).
Writes to the display's character cells are translated into ANSI
terminal sequences which are then sent out the PC-Weasel's serial
port.
Incoming characters are translated into PC keyboard scan codes and
then fed (by means of a cable) into the system's keyboard controller.
The system believes it is using a display console.
This is particularly important in the event that one needs access
to BIOS configuration menus.
.Pp
The PC-Weasel also includes a ST16550 serial port, which may
be configured as any one of the system's serial ports.
Typical usage is to configure the port as
.Em com0
at ISA I/O address 0x3f8.
When the PC-Weasel detects activity on the ST16550, the serial port
is automatically connected to the ST16550 so that the serial port
may be used as normal.
When the PC-Weasel detects activity on the internal UART used for
MDA emulation, the serial port is automatically reconnected to the
emulation UART.
This allows the boot program and kernel to be configured to use
the serial port directly (which is more efficient than using the
MDA emulation mode), yet allows the MDA emulation to be reestablished
as soon as the kernel loses control of the system.
.Pp
The
.Nm
driver provides support for the additional features present on
the PC-Weasel.
At the moment, this includes support for the watchdog timer function.
Use of the
.Nm
driver is not required in order for the system to function with
a PC-Weasel installed so long as only the MDA emulation and
ST16550 serial port functionality is required.
.Sh SEE ALSO
.Xr pcdisplay 4 ,
.Xr wdogctl 8
.Sh HISTORY
The
.Nm
driver first appeared in
.Nx 1.5.1 .
.Sh AUTHORS
The PC-Weasel was invented by Herb Peyerl and Jonathan Levine
at Canada Connect Corporation.
It is now produced by Middle Digital, Inc., http://www.realweasel.com/
.Pp
The
.Nm
driver was written by
.An Jason R. Thorpe
.Aq thorpej@zembu.com ,
and contributed by Zembu Labs, Inc.
Herb Peyerl of Middle Digital, Inc.
provided several firmware updates during the
development of the driver.
